# Changelog

## 2025-02-04 - 3.0.64 - fix(serviceworker)
Improve cache handling and response header management in service worker.

- Addressed issue preventing caching of certain responses due to missing CORS headers.
- Added 'Vary: Origin' header to ensure proper response handling.
- Included 'Access-Control-Expose-Headers' for better CORS support.

## 2025-02-04 - 3.0.63 - fix(core)
Refactored caching strategy for service worker to improve compatibility and performance.

- Removed hard and soft caching distinctions.
- Simplified cache setup process.
- Improved browser caching control headers.

## 2025-02-04 - 3.0.62 - fix(Service Worker)
Refactor and clean up the cache logic in the Service Worker to improve maintainability and handle Safari-specific cache behavior.

- Refactored logic for determining cached domains, enhancing the readability and maintainability of the code.
- Improved handling of CORS settings in caching requests, notably bypassing caching for soft cached domains in Safari to avoid CORS issues.
- Enhanced error response creation for failed resource fetching, maintaining clarity on why and how certain resources were not fetched or cached.
- Revised the structure of the caching logic to ensure consistent behavior across all supported browsers.

## 2025-02-04 - 3.0.61 - fix(ServiceWorkerCacheManager)
Fixed caching mechanism to better support Safari's handling of soft-cached domains.

- Added logic to differentiate between hard and soft cached domains.
- Implemented special handling for soft cached domains on Safari by bypassing caching.
- Ensured appropriate CORS headers are present in cached responses.
- Improved error handling with informative 500 error responses.
- Optimized caching logic to prevent redundant caching and potential issues with locked streams on Safari.

## 2025-02-04 - 3.0.61 - fix(ServiceWorkerCacheManager)
Fixed caching mechanism to better support Safari's handling of soft-cached domains.

- Added logic to differentiate between hard and soft cached domains.
- Implemented special handling for soft cached domains on Safari by bypassing caching.
- Ensured appropriate CORS headers are present in cached responses.
- Improved error handling with informative 500 error responses.
- Optimized caching logic to prevent redundant caching and potential issues with locked streams on Safari.

## 2025-02-04 - 3.0.61 - fix(ServiceWorkerCacheManager)
Fixed caching mechanism to better support Safari's handling of soft-cached domains.

- Added logic to differentiate between hard and soft cached domains.
- Implemented special handling for soft cached domains on Safari by bypassing caching.
- Ensured appropriate CORS headers are present in cached responses.
- Improved error handling with informative 500 error responses.
- Optimized caching logic to prevent redundant caching and potential issues with locked streams on Safari.

## 2025-02-04 - 3.0.60 - fix(cachemanager)
Improve cache management and error handling

- Updated comments for clarity and consistency.
- Enhanced error handling in `fetch` event listener.
- Optimized cache key management and cleanup process.
- Ensured CORS headers are set for cached responses.
- Improved logging for caching operations.

## 2025-02-03 - 3.0.59 - fix(serviceworker)
Fixed CORS and Cache Control handling for Service Worker

- Improved handling of CORS settings for external requests.
- Preserved important headers while excluding caching headers.
- Ensured the presence of CORS headers in cached responses.
- Adjusted Cache-Control headers to prevent browser caching but allow service worker caching.

## 2025-02-03 - 3.0.58 - fix(network-manager)
Refined network management logic for better offline handling.

- Improved logic to handle missing connections more gracefully.
- Added detailed online/offline connection status logging.
- Implemented a check for stale cache with a grace period for offline scenarios.
- Network requests now use optimized retries and timeouts.

## 2025-02-03 - 3.0.57 - fix(updateManager)
Refine cache management for service worker updates.

- Ensured cache is forcibly updated if older than defined maximum age.
- Implemented interval checks and forced updates for cache staleness.
- Updated version information and cache timestamps upon forced updates or validations.

## 2025-02-03 - 3.0.56 - fix(cachemanager)
Adjust cache control headers and fix redundant code

- Remove duplicate assetbroker URLs in the cache evaluation logic.
- Update cache control headers to improve caching behavior.
- Increase the timeout for fetch operations to improve compatibility.

## 2025-01-28 - 3.0.55 - fix(server)
Fix response content manipulation for HTML files with injectReload

- Moved fileString declaration inside HTML file handling block to prevent unnecessary string conversion for non-HTML files.
- Corrected responseContent assignment to ensure modified HTML strings are converted back to Buffer format.

## 2025-01-28 - 3.0.54 - fix(servertools)
Fixed an issue with compression results handling in HandlerStatic where content was always being written even if not compressed.

- Corrected the double writing of response in HandlerStatic.
- Ensured that file buffers are only conditionally written based on compression availability.

## 2024-12-26 - 3.0.53 - fix(infohtml)
Remove Sentry script and logo from HTML template

- Removed Sentry script from the HTML template.
- Removed Lossless GmbH logo and contact info.
- Updated footer link to point to foss.global.

## 2024-12-25 - 3.0.52 - fix(dependencies)
Bump package versions in dependencies and exports.

- Updated package dependencies to their latest versions.
- Added './infohtml' in package exports.

## 2024-08-27 - 3.0.51 - fix(core)
Update dependencies and fix service worker cache manager and task manager functionalities

- Updated dependencies in package.json to their latest versions
- Enhanced service worker cache manager to include additional scoped URLs
- Fixed task manager to start the task manager and added update task functionality
- Removed .gitlab-ci.yml from the repository as part of the cleanup

## 2024-05-25 - 3.0.43 to 3.0.50 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.43 to 3.0.50

## 2024-05-23 - 3.0.37 to 3.0.42 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.37 to 3.0.42

## 2024-05-17 - 3.0.37 - Core
Routine update and bug fix

- Updated core functionalities

## 2024-05-14 - 3.0.33 to 3.0.36 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.33 to 3.0.36

## 2024-05-13 - 3.0.31 to 3.0.32 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.31 to 3.0.32

## 2024-05-11 - 3.0.29 to 3.0.31 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.29 to 3.0.31

## 2024-04-19 - 3.0.27 to 3.0.28 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.27 to 3.0.28

## 2024-04-14 - 3.0.27 - Documentation
Updated Documentation

- Improved and updated documentation

## 2024-03-01 - 3.0.25 to 3.0.26 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.25 to 3.0.26

## 2024-02-21 - 3.0.20 to 3.0.24 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.20 to 3.0.24

## 2024-01-19 - 3.0.19 to 3.0.20 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.19 to 3.0.20

## 2024-01-09 - 3.0.14 to 3.0.18 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.14 to 3.0.18

## 2024-01-08 - 3.0.11 to 3.0.13 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.11 to 3.0.13

## 2024-01-07 - 3.0.9 to 3.0.10 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.9 to 3.0.10

## 2023-11-06 - 3.0.8 to 3.0.9 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.8 to 3.0.9

## 2023-10-23 - 3.0.6 to 3.0.7 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.6 to 3.0.7

## 2023-10-20 - 3.0.5 to 3.0.6 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.5 to 3.0.6

## 2023-09-21 - 3.0.4 to 3.0.5 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.4 to 3.0.5

## 2023-08-06 - 3.0.2 to 3.0.3 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.2 to 3.0.3

## 2023-08-03 - 3.0.1 to 3.0.0 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 3.0.1 to 3.0.0

## 2023-08-03 - 2.0.65 - Core
Breaking change in core update

- Introduced breaking changes updating core functionalities

## 2023-07-02 - 2.0.59 to 2.0.64 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.59 to 2.0.64

## 2023-07-01 - 2.0.54 to 2.0.58 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.54 to 2.0.58

## 2023-06-12 - 2.0.53 - Core
Routine update and bug fix

- Updated core functionalities

## 2023-04-10 - 2.0.52 to 2.0.53 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.52 to 2.0.53

## 2023-04-04 - 2.0.49 to 2.0.51 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.49 to 2.0.51

## 2023-03-31 - 2.0.45 to 2.0.48 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.45 to 2.0.48

## 2023-03-30 - 2.0.37 to 2.0.44 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.37 to 2.0.44

## 2023-03-29 - 2.0.33 to 2.0.36 - Core
Routine updates and bug fixes

- Updated core functionalities for better performance and stability in versions 2.0.33 to 2.0.36
